.686p
.model flat
include ..\Macros.inc
include ..\EBasic.inc
; ===========================================================================
extrn ebvarstable	:near
extrn sorttable		:near
extrn AscCmp		:byte
extrn SortSTRING	:near
extrn Direction		:dword
; ===========================================================================
.code
;$command ArraySearchColumnS(Array:POINTER,Typ:UINT,UboundColumn:UINT,UboundRow:UINT,Find:POINTER,OPT Row=0:UINT,OPT Up=1:UINT),INT
;Search in sorted array (bubble search)
; =============== S U B	R O U T	I N E =======================================
ArraySearchColumnS proc near syscall public uses esi edi ebx Array:POINTER,Typ:UINT,UboundColumn:UINT,UboundRow:UINT,Find:POINTER,Row:UINT,Up:UINT
		LOCAL Base	:DWORD
		LOCAL Jump	:DWORD
		mov	eax, UboundColumn
		inc eax
		push eax
		mov esi, Array									;ESI = Array
		movzx eax, byte ptr Typ
		lea edi,  ebvarstable
		movzx edi, word ptr [edi+eax*2]
		.if (al == @TYPESTRING) && (AscCmp == FALSE) 	;EBX = &cmpfunc
			lea ebx, SortSTRING
		.else
			lea ebx, sorttable
			mov ebx, [ebx+eax*4]
		.endif
		mov Jump, ebx
		m2m Direction, Up
		mov eax, Row
		mul edi
		add esi, eax
		mov Base, esi
		mov eax, UboundRow
		inc	eax
		mul	edi
		xchg edi, eax
		xor ebx, ebx
@@:		pop ecx
		jecxz	NotFound
		shr	ecx, 1
		setnc bl
		push ecx
		mov	eax, edi
		mul	ecx
		add eax, esi
		mov ecx, Find
		xchg eax, ecx
		invokeE [Jump]
		jb	@B
		je  @F
		mov esi, ecx
		add esi, edi
		sub [esp], ebx
		jmp @B
@@:		sub ecx, Base
		xchg eax, ecx
		xor edx, edx
		div edi
		pop ecx	
@@:		ret 28
NotFound:xchg eax, ecx
		dec eax
		jmp @B		
ArraySearchColumnS endp
end