.686p
.model flat
.xmm
include ..\Macros.inc
include ..\EBasic.inc
; ===========================================================================
Public QIThreshHold
Public PChainedArrays
; ===========================================================================
extrn SortSTRING    :near
extrn Direction		:byte
extrn ebvarstable	:near
extrn sorttable		:near
extrn swaptable		:near
extrn AscCmp		:byte
; ===========================================================================
.data
	align 4
	QIThreshHold	dd 30
	PChainedArrays	dd 0
.data?
	align 4
	array			dd ?
	uboundRow		dd ?
	sortMask		dd ?
; ===========================================================================
.code
;$command ArraySortColumn(Array:POINTER,Typ:UINT,UboundRow:UINT,OPT SortBy=0:UINT,OPT SortMask=1:UINT,OPT Up=1:UINT,OPT SizeOfElement=0:UINT)
; =============== S U B	R O U T	I N E =======================================
ArraySortColumn proc near syscall public uses esi edi ebx Array:POINTER,Typ:UINT,UboundRow:UINT,SortBy:UINT,SortMask:UINT,Up:UINT,SizeOfElement:UINT
		mov ebx, SizeOfElement
		mov al, byte ptr Up
		invokeL Parse
		m2m sortMask, SortMask
		mov eax, UboundRow
		inc eax
		mul ebx
		mov uboundRow, eax
		mov	ecx, SortBy
		mul	ecx
		mov esi, Array
		add	esi, eax
		invokeL QSortColumn, 0,UboundRow
		jmp Exit
ArraySortColumn endp
;$command ArraySortRow(Array:POINTER,Typ:UINT,UboundColumn:UINT,UboundRow:UINT,OPT SortBy=0:UINT,OPT SortMask=1:UINT,OPT Up=1:UINT)
; =============== S U B	R O U T	I N E =======================================
ArraySortRow proc near syscall public uses esi edi ebx Array:POINTER,Typ:UINT,UboundCol:UINT,UboundRow:UINT,SortBy:UINT,SortMask:UINT,Up:UINT
		xor ebx, ebx
		mov al, byte ptr Up
		invokeL Parse
		m2m sortMask, SortMask
		mov	eax, SortBy
		mul	ebx
		mov esi, Array
		add	esi, eax		
		mov eax, UboundRow
		inc eax
		mul ebx
		xchg ebx, eax
		mov uboundRow, eax
		invokeL QSortColumn, 0,UboundCol
		jmp Exit
; =============== S U B	R O U T	I N E =======================================
Parse::	mov Direction, al
		movzx	eax, byte ptr Typ
		xor ecx, ecx
		movd xmm5, ecx
		lea esi, swaptable
		mov esi, [esi+eax*4]
		lea edi, sorttable
		mov edi, [edi+eax*4]	
		.if (ebx == 0)
			lea ebx, ebvarstable
			movzx ebx, word ptr [ebx+eax*2]
		.endif
		.if (al == @TYPESTRING)
			inc ecx
			movd xmm5, ecx
			.if (byte ptr AscCmp == 0)
				lea edi, SortSTRING
			.endif
		.elseif (al == @TYPEWSTRING)
			inc ecx
			inc ecx
			movd xmm5, ecx
		.elseif (ebx == 0)
			pop eax
Exit::		ret 28
		.endif
		movd xmm7, esi
		m2m array, Array
		retn
ArraySortRow endp
; =============== S U B	R O U T	I N E =======================================
align 16
QSortColumn proc near syscall private Left:SDWORD,Right:SDWORD
	LOCAL L		:SDWORD
	LOCAl R		:SDWORD
	mov eax, Left
	mov edx, Right
	mov L, eax
	mov R, edx
	sub edx, eax
	.if (edx > SDWORD ptr QIThreshHold)
		;QUICK Sort
		add eax, Right
		shr eax, 1
		mul ebx
		add eax, esi
		movd ecx, xmm5
		.if (ecx != 0)
			pushREV eax,eax
			.if (ecx == 1)
				invokeE _ibstrlen
				inc eax
			.else
				invokeE WLEN$
				inc eax
				shl eax, 1
			.endif
			pop ecx
			xchg ecx, eax
		.else
			mov ecx, ebx
		.endif
		pushREV eax,ecx
		inc ecx
		invokeE AllocHeap, ecx
		movd xmm6, eax
		invokeA RtlMoveMemory, eax
		mov edx, R
		.while (L <= edx)
			movd ecx, xmm6
		@@:	mov eax, L
			mul ebx
			add eax, esi
			call edi
			jae @F
				inc L
				jmp @B
		@@:	mov eax, R
			mul ebx
			add eax, esi
			call edi
			jbe @F
				dec R
				jmp @B
		@@:	mov ecx, L
			mov eax, R
			.if (ecx <= SDWORD ptr eax)
				movd xmm3, eax 
				mul ebx
				add eax, array
				push eax
				movd xmm4, ecx
				xchg eax, ecx
				mul ebx
				add eax, array
				push eax
				invokeL SwapLoop
				inc L
				dec R
			.endif
			mov edx, R
		.endw
		movd eax, xmm6
		invokeE FreeHeap, eax
		mov eax, Left
		mov ecx, R
		.if (eax < ecx)
			invokeL QSortColumn, eax,ecx
		.endif
		mov eax, Right
		mov ecx, L
		.if (ecx < eax)
			invokeL QSortColumn, ecx,eax
		.endif		
	.else
		;INSERTION Sort
		inc L
		mov eax, Right
		.while (L <= eax)
			mov ecx, L
@@:			dec ecx
			mov R, ecx
			.if (!SIGN?)
				xchg eax, ecx
				mul ebx
				add eax, esi
				mov ecx, eax
				add eax, ebx
				call edi
				jae @F
					mov eax, R
					movd xmm3, eax
					inc eax
					movd xmm4, eax
					mul ebx
					add eax, array
					push eax
					sub eax, ebx
					push eax
					invokeL SwapLoop
					mov ecx, R
					jmp @B
			.endif
			@@:inc L
			mov eax, Right
		.endw
	.endif	
	ret 8
QSortColumn endp
; =============== S U B	R O U T	I N E =======================================
align 16
SwapLoop proc near syscall private uses esi edi ebx Mem01:DWORD,Mem02:DWORD
		LOCAL ArrayChain	:DWORD
		mov esi, sortMask
		movd edi, xmm7
		call Domask
		mov esi, PChainedArrays
		.if (esi != 0)
			m2m ArrayChain, esi
		@@:	mov ecx, [esi]
			jecxz @F
				mov edx, [esi+4]
				lea edi, swaptable
				mov edi, [edi+edx*4]
				mov ebx, [esi+12]
				.if (ebx == 0)
					lea ebx, ebvarstable
					movzx ebx, word ptr [ebx+edx*2]
				.endif
				movd eax, xmm3
				mul ebx
				add eax, ecx
				mov Mem01, eax
				movd eax, xmm4
				mul ebx
				add eax, ecx
				mov Mem02, eax
				add esi, 16
				mov ArrayChain, esi
				mov esi, [esi-8]
				call Domask
				mov esi, ArrayChain
			jmp @B
		.endif
@@:		ret 8
Domask:	.repeat
			shr esi, 1
			.if (CARRY?)
				invokeE edi, Mem01,Mem02
			.endif
			mov eax, uboundRow
			add Mem01, eax
			add Mem02, eax
		.until (esi == 0)
		retn
SwapLoop endp
end 