.686p
.model flat
include ..\Macros.inc
; ========================================
.data
	align 4
	public Direction
	Direction	db 0
.code
; Arguments in EAX,ECX
; Preservs ECX destroys EDX,EAX
; =============== S U B R O U T I N E ====
align 8
SortBYTE proc near public
			mov al, [eax]
			mov ah, [ecx]
			.if (Direction == 0)
				xchg	al, ah
			.endif
			cmp al, ah
			retn
SortBYTE endp
; =============== S U B R O U T I N E ====
align 8
SortWORD proc near public
			mov ax, [eax]
			mov dx, [ecx]
			.if (Direction == 0)
				xchg	ax, dx
			.endif
			cmp ax, dx
			retn
SortWORD endp
; =============== S U B R O U T I N E ====
align 8
SortDWORD proc near public
			mov eax, [eax]
			mov edx, [ecx]
			.if (Direction == 0)
				xchg	eax, edx
			.endif
			cmp eax, edx
			retn
SortDWORD endp
; =============== S U B R O U T I N E ====
align 8
SortQWORD proc near public
			push ecx
			mov edx, [eax+4]
			mov ecx, [ecx+4]
			.if (Direction == 0)
				xchg	ecx, edx
			.endif
			cmp edx, ecx
			pop ecx
			jz SortDWORD	
			retn
SortQWORD endp
; =============== S U B R O U T I N E ====
align 8
SortFLOAT proc near public
			fld dword ptr [ecx] 
			fld dword ptr [eax]
			jmp L0
SortFLOAT endp
; =============== S U B R O U T I N E ====
align 8
SortDOUBLE proc near public
			fld qword ptr [ecx]
			fld qword ptr [eax]
L0::		.if (Direction == 0)
				fxch st(1)
			.endif
			fucomip st(0), st(1)
			ffreep st(0)
			retn
SortDOUBLE endp
; =============== S U B R O U T I N E ====
align 8
SortSQWORD proc near public
			fild qword ptr [ecx]
			fild qword ptr [eax]
			jmp L0
SortSQWORD endp
; =============== S U B R O U T I N E ====
align 8
SortASCSTRING proc near public
			push ecx
			.if (Direction == 0)
				xchg	eax, ecx
			.endif
			invokeE STRCMP$, eax,ecx
			pop ecx 
			retn
SortASCSTRING endp
; =============== S U B R O U T I N E ====
align 8
SortSBYTE proc near public
			mov al, [eax]
			mov ah, [ecx]
			.if (Direction == 0)
				xchg	al, ah
			.endif
			cmp ah, al
			jmp SCMP
SortSBYTE endp
; =============== S U B R O U T I N E ====
align 8
SortSWORD proc near public
			mov ax, [eax]
			mov dx, [ecx]
			.if (Direction == 0)
				xchg	ax, dx
			.endif
			cmp dx, ax
			jmp SCMP
SortSWORD endp
; =============== S U B R O U T I N E ====
align 8
SortSDWORD proc near public
			mov eax, [eax]
			mov edx, [ecx]
			.if (Direction == 0)
				xchg	eax, edx
			.endif
			cmp edx, eax
			jmp SCMP
SortSDWORD endp
; ========================================
SCMP::	jz Exit
		sets dl
		seto dh
		cmp dh, dl
		jz @F
		test dh, dl
		jnz @F
		not dh
@@: 	inc dl
		cmp dh, dl
Exit: 	retn
; =============== S U B R O U T I N E ====
align 8
SortWSTRING proc near public
			push ecx
			.if (Direction == 0)
				xchg	eax, ecx
			.endif
			invokeA lstrcmpW, eax,ecx
			pop ecx
			xor edx, edx
			cmp edx, eax
			jmp SCMP
SortWSTRING endp
; =============== S U B R O U T I N E ====
align 8
SortSTRING proc near public
			push ecx
			.if (Direction == 0)
				xchg	eax, ecx
			.endif
			invokeA lstrcmpA, eax,ecx
			pop ecx
			xor edx, edx
			cmp edx, eax
			jmp SCMP
SortSTRING endp
end
