.686p
.model flat
; ===========================================================================
.code
;$command SWAP$(String1:STRING,String2:STRING)
; =============== S U B R O U T I N E =======================================
align 16
SWAP$ proc near syscall public uses esi edi ebx String1:DWORD,String2:DWORD 
		mov 	edi, String1
		mov 	esi, String2
		test 	edi, esi
		jz 		Exit
		mov 	edx, -4
R1:		not 	edx
C0:		test 	edi, edx
		jz 		noalign						
		mov 	ah, [edi]
		mov 	al, [esi]
		test	ax, ax
		jz		Exit
		stosb
		mov 	[esi], ah
		inc 	esi
		jmp 	C0
noalign:mov 	dl, 2					;eax <> ebx
		mov 	ebx, [edi]
		mov 	eax, [esi]
		test 	ebx, ebx
		jz 		Long1
		test 	eax, eax
		jz 		Long0
C1:		mov 	cl, bl
		mov 	ch, al
		jcxz 	R1  
		mov 	cl, bh
		mov 	ch, ah
		jcxz 	R1
		bswap 	eax
		bswap 	ebx
		sub 	edx, 1
		jnz 	C1
		mov		[edi], eax
		mov 	[esi], ebx
		add		edi, 4
		add 	esi, 4
		jmp 	noalign
Exit:	ret 	8
Long0:	xchg 	ebx, eax
		xchg 	edi, esi
Long1:	mov 	[esi], bl	
		inc 	edx
		inc 	edx
R2:		test 	al, al
		jz 		Exit
		test 	ah, ah
		jz 		IsByte
		mov 	ecx, eax
		bswap 	ecx
		test 	ch, ch
		jz 		IsWord
		stosd
		add 	esi, edx
		mov 	eax, [esi]
		jmp 	R2
IsByte: mov 	[edi], ax
		jmp 	Exit
IsWord: mov 	[edi+2], ch
		jmp 	IsByte 
SWAP$ endp
end
