;Turbo Emergence Basic Include file
OPTION NOKEYWORD:<Invoke>
; ------------------------------------------------------------------
EB_HANDLERS STRUCT
	pControl 	DWORD ?
	pMenu    	DWORD ?
	pMenuInit	DWORD ?
	pMessage 	DWORD ?
EB_HANDLERS ENDS
; ------------------------------------------------------------------
WINRECT STRUCT
  left    DWORD	?
  top     DWORD	?
  right   DWORD	?
  bottom  DWORD	?
WINRECT ENDS
; ------------------------------------------------------------------
WINDOWLIST STRUCT
	pNext			DWORD ?
	pData 			DWORD ?
WINDOWLIST ENDS
; ------------------------------------------------------------------
EBBrowser STRUCT
	m_fpUnEmbed 			DWORD ?
	m_fpBrowserTranslate	DWORD ?
	m_fpBrowserSize			DWORD ?
	m_bBackEnabled			DWORD ?
	m_bForeEnabled			DWORD ?
	m_dwEventCookie			DWORD ?
	m_fpUnsinkEvents		DWORD ?
	m_lpStrPost				DWORD ?
	m_lpStrHeaders			DWORD ?
	m_lpStrNav				DWORD ?
	m_bCancel				DWORD ?
	m_lpStatusText			DWORD ?
EBBrowser ENDS
; ------------------------------------------------------------------
POINT STRUCT
  	x  				DWORD ?
  	y  				DWORD ?
POINT ENDS
; ------------------------------------------------------------------
WINDOW STRUCT
	hWnd			DWORD	?
	hBitmap			DWORD	?
	hFont			DWORD	?
	hPen			DWORD	?
	hClient			DWORD	?
	m_pos			POINT	<>
	m_iBkMode		DWORD	?
	m_iROP2			DWORD	?
	m_nPenStyle		DWORD	?
	m_nPenWidth		DWORD	?
	m_cBack			DWORD	?
	m_cWindow		DWORD	?
	m_bAutoDraw		DWORD	?
	m_bTabEnable	DWORD	?
	m_hCursor		DWORD	?
	m_hBackDC		DWORD	?
	m_hCacheDC		DWORD	?
	m_nCacheCount	DWORD	?
	m_bDialog		DWORD	?
	m_pDlgTemplate	DWORD	?
	m_pIB2DScreen	DWORD	?
	m_pIB2DSurface	DWORD	?
	hProcedure		DWORD	?
	m_pBrowser		DWORD	?
	m_hPrintDC		DWORD	?
WINDOW ENDS
; ------------------------------------------------------------------
EBDLGTEMPLATE STRUCT
    style			DWORD	?
    dwExtendedStyle	DWORD	?
    caption			BYTE 256 DUP(?)	
	parent			DWORD	?
    x				DWORD	?
    y				DWORD	?
    lx				DWORD	?
    ly				DWORD	?
	m_nSizeX		DWORD	?
	m_nSizeY		DWORD	?
	ctrllist		DWORD	?
	m_bNonModal		DWORD	?
EBDLGTEMPLATE ENDS
; ------------------------------------------------------------------
EBDLGITEMTEMPLATE STRUCT
	pNext			DWORD ?
	style			DWORD ?
	dwExtendedStyle	DWORD ?
	caption			DWORD ?
	classname		BYTE 32 DUP(?)
	typ				DWORD ?
	x				DWORD ?
	y				DWORD ?
	lx				DWORD ?
	cy				DWORD ?
	id				DWORD ?
	defbutton		DWORD ?	;this button is the default button.
EBDLGITEMTEMPLATE ENDS
; ------------------------------------------------------------------
OnExitData STRUCT
	fn 		DWORD ?
	pData	DWORD ?
OnExitData ENDS
; ------------------------------------------------------------------
TOOLENUMSTRUCT STRUCT
	ClientRect 	WINRECT	<>
	bUpdate 	DWORD ?
TOOLENUMSTRUCT ENDS
; ------------------------------------------------------------------
CONTROLENUMSTRUCT STRUCT
	hParent	DWORD ?
	hDC		DWORD ?
CONTROLENUMSTRUCT ENDS
; -------------------------------------------------------------------
LINKEDLIST STRUCT
	pNext	DWORD ?
	pPrev   DWORD ?
	pData 	DWORD ?
LINKEDLIST ENDS
; -------------------------------------------------------------------
RE_COOKIE STRUCT
	vType	DWORD	?
	Pdata	DWORD	?
RE_COOKIE ENDS
; -------------------------------------------------------------------
IAssoc STRUCT
	pNext		DWORD ?
	nHashValue	DWORD ?
	key			DWORD ?
	value		DWORD ?
IAssoc ENDS
; -------------------------------------------------------------------
IDispatch STRUCT
; --- IUnknown methods ---
STDMETHOD QueryInterface,riid:POINTER,ppvObj:POINTER
STDMETHOD AddRef
STDMETHOD Release
; --- IDispatch methods ---
STDMETHOD GetTypeInfoCount,pctinfo:UINT BYREF
STDMETHOD GetTypeInfo,iTInfo:UINT,lcid:POINTER,ppTInfo:POINTER
STDMETHOD GetIDsOfNames,riid:GUID,rgszNames:STRING,cNames:UINT,lcid:POINTER,rgDispID:GUID
STDMETHOD Invoke,dispIdMember:UINT,riid:GUID,lcid:POINTER,wFlags:WORD,pDispParams:POINTER,pVarResult:POINTER,pExcepInfo:POINTER,puArgErr:UINT BYREF
IDispatch ENDS
; -------------------------------------------------------------------
PWINDOW TYPEDEF PTR WINDOW
POINTER TYPEDEF DWORD
MEMORY  TYPEDEF DWORD
CHAR	TYPEDEF BYTE
SCHAR	TYPEDEF SBYTE
FLOAT	TYPEDEF REAL4
DOUBLE 	TYPEDEF REAL8
STRING  TYPEDEF DWORD
WSTRING TYPEDEF DWORD
UINT	TYPEDEF DWORD
UINT64  TYPEDEF QWORD
INT64   TYPEDEF QWORD
; -------------------------------------------------------------------
TRUE			equ 1
FALSE			equ 0
SW_NORMAL 		equ 1
FILE_BEGIN		equ 0
FILE_CURRENT	equ 1
FILE_END		equ 2
GHND 			equ 42h
GMEM_FIXED 		equ 0
GMEM_MOVEABLE 	equ 2
GMEM_ZEROINIT 	equ 40h
GPTR 			equ 40h
BIF_EDITBOX		equ 10h
BIF_STATUSTEXT 	equ 4
GWL_STYLE       equ -16
NULL			equ 0
ONE				equ 1
MINUSONE		equ -1
EB_WM_CASCADE 	equ 8005h
EB_WM_TILE 		equ 8006h
EB_WM_ARRANGE 	equ 8007h
BYREF			equ 10000h
; ---------------------- CORE ----------------------------------------
@IDDRAGENTER	equ	40960
@IDDRAGOVER	equ	40961
@IDDRAGLEAVE	equ	40962
@IDDRAGDROP	equ	40963
@IDDRAGFEEDBACK	equ	40964
@TNOE	equ	0
@RoundDown	equ	1024
@RoundUP	equ	2048
@Truncate	equ	3072
@HCR	equ	-2147483648
@HCU	equ	-2147483647
@HLM	equ	-2147483646
@HU	equ	-2147483645
@HCC	equ	-2147483643
@HDD	equ	-2147483642
@REG_NONE	equ	0
@REG_SZ	equ	1 
@REG_EXPAND_SZ	equ	2
@REG_BINARY	equ	3
@REG_DWORD	equ	4
@REG_DWORD_BIG_ENDIAN	equ	5
@REG_LINK	equ	6
@REG_MULTI_SZ	equ	7
@REG_QWORD	equ	11
@CSWAIT	equ	32514
@CSARROW	equ	32512
@CSCUSTOM	equ	0
@CSIDL_DESKTOP	equ	0
@CSIDL_INTERNET	equ	1
@CSIDL_PROGRAMS	equ	2
@CSIDL_CONTROLS	equ	3
@CSIDL_PRINTERS	equ	4
@CSIDL_PERSONAL	equ	5
@CSIDL_FAVORITES	equ	6
@CSIDL_STARTUP	equ	7
@CSIDL_RECENT	equ	8
@CSIDL_SENDTO	equ	9
@CSIDL_BITBUCKET	equ	10
@CSIDL_STARTMENU	equ	11
@CSIDL_MYDOCUMENTS	equ	12
@CSIDL_MYMUSIC	equ	13
@CSIDL_MYVIDEO	equ	14
@CSIDL_DESKTOPDIRECTORY	equ	16
@CSIDL_DRIVES	equ	17
@CSIDL_NETWORK	equ	18
@CSIDL_NETHOOD	equ	19
@CSIDL_FONTS	equ	20
@CSIDL_TEMPLATES	equ	21
@CSIDL_COMMON_STARTMENU	equ	22
@CSIDL_COMMON_PROGRAMS	equ	23
@CSIDL_COMMON_STARTUP	equ	24
@CSIDL_COMMON_DESKTOPDIRECTORY	equ	25
@CSIDL_APPDATA	equ	26
@CSIDL_PRINTHOOD	equ	27
@CSIDL_LOCAL_APPDATA	equ	28
@CSIDL_ALTSTARTUP	equ	29
@CSIDL_COMMON_ALTSTARTUP	equ	30
@CSIDL_COMMON_FAVORITES	equ	31
@CSIDL_INTERNET_CACHE	equ	32
@CSIDL_COOKIES	equ	33
@CSIDL_HISTORY	equ	34
@CSIDL_COMMON_APPDATA	equ	35
@CSIDL_WINDOWS	equ	36
@CSIDL_SYSTEM	equ	37
@CSIDL_PROGRAM_FILES	equ	38
@CSIDL_MYPICTURES	equ	39
@CSIDL_PROFILE	equ	40
@CSIDL_SYSTEMX86	equ	41
@CSIDL_PROGRAM_FILESX86	equ	42
@CSIDL_PROGRAM_FILES_COMMON	equ	43
@CSIDL_PROGRAM_FILES_COMMONX86	equ	44
@CSIDL_COMMON_TEMPLATES	equ	45
@CSIDL_COMMON_DOCUMENTS	equ	46
@CSIDL_COMMON_ADMINTOOLS	equ	47
@CSIDL_ADMINTOOLS	equ	48
@CSIDL_CONNECTIONS	equ	49
@CSIDL_COMMON_MUSIC	equ	53
@CSIDL_COMMON_PICTURES	equ	54
@CSIDL_COMMON_VIDEO	equ	55
@CSIDL_RESOURCES	equ	56
@CSIDL_RESOURCES_LOCALIZED	equ	57
@CSIDL_COMMON_OEM_LINKS	equ	58
@CSIDL_CDBURN_AREA	equ	59
@CSIDL_COMPUTERSNEARME	equ	61
@GROUP	equ	131072
@SWRESTORE	equ	9
@SWMINIMIZED	equ	2
@SWMAXIMIZED	equ	3
@SWHIDE	equ	0
@SWSHOW	equ	5
@NOAUTODRAW	equ	16
@MDIFRAME	equ	32
@NOCAPTION	equ	64
@FIXEDSIZE	equ	128
@AUTOSCALE	equ	256
@TOOLWINDOW	equ	512
@TOPMOST	equ	1024
@HIDDEN	equ	2048
@TABSTOP	equ	65536
@USEDEFAULT	equ	-2147483648
@MINIMIZED	equ	536870912
@MAXIMIZED	equ	16777216
@SIZE	equ	262144
@CAPTION	equ	12582912
@MINBOX	equ	131072
@SYSMENU	equ	524288
@MAXBOX	equ	65536
@HSCROLL	equ	1048576
@VSCROLL	equ	2097152
@IDLBUTTONDBLCLK	equ	515
@IDLBUTTONUP	equ	514
@IDRBUTTONUP	equ	517
@IDMOUSEMOVE	equ	512
@IDLBUTTONDN	equ	513
@IDRBUTTONDN	equ	516
@IDRBUTTONDBLCLK	equ	518
@IDCONTROL	equ	32772
@IDCLOSEWINDOW	equ	32770
@IDMENUPICK	equ	32771
@IDDXUPDATE	equ	32780
@IDMENUINIT	equ	278
@MULTISELECT	equ	512
@IDREQCLEAR	equ	4096
@IDOK	equ	1
@IDSIZE	equ	32777
@IDSIZING	equ	532
@IDSIZECHANGED	equ	5
@IDMOVE	equ	3
@IDMOVING	equ	534
@IDHSCROLL	equ	276
@IDVSCROLL	equ	277
@IDINITDIALOG	equ	272
@IDCANCEL	equ	2
@IDCHAR	equ	258
@IDKEYDOWN	equ	256
@IDKEYUP	equ	257
@IDTIMER	equ	275
@IDPAINT	equ	15
@IDCHANGEWINDOW	equ	33554432
@TRANSPARENT	equ	1
@OPAQUE	equ	2
@SFITALIC	equ	1
@SFUNDERLINE	equ	16
@MENUCHECK	equ	8
@MENUDISABLE	equ	1
@CTEDITLEFT	equ	0
@CTEDITRIGHT	equ	2
@CTEDITMULTI	equ	4
@CTEDITPASS	equ	32
@CTEDITCENTER	equ	1
@CTEDITRO	equ	2048
@BORDER	equ	8388608
@CTLISTEXTENDED	equ	2048
@CTLISTMULTI	equ	8
@CTLISTSORT	equ	2
@CTLISTSTANDARD	equ	10485763
@CTLISTNOTIFY	equ	1
@CTLISTTABS	equ	128
@CTLISTCOLUMNS	equ	512
@CTSCROLLHORIZ	equ	0
@CTSCROLLVERT	equ	1
@CTCOMBODROPDOWN	equ	2
@CTCOMBODROPLIST	equ	3
@SBLEFT	equ	6
@SBENDSCROLL	equ	8
@SBLINELEFT	equ	0
@SBLINERIGHT	equ	1
@SBPAGELEFT	equ	2
@SBPAGERIGHT	equ	3
@SBRIGHT	equ	7
@SBTHUMBPOS	equ	4
@SBTHUMBTRACK	equ	5
@SBBOTTOM	equ	7
@SBLINEDOWN	equ	1
@SBLINEUP	equ	0
@SBPAGEDOWN	equ	3
@SBPAGEUP	equ	2
@SBTOP	equ	6
@RMBLACK	equ	1
@RMWHITE	equ	16
@RMNOP	equ	11
@RMNOT	equ	6
@RMCOPYPEN	equ	13
@RMNOTCOPYPEN	equ	4
@RMMERGEPENNOT	equ	14
@RMMASKPENNOT	equ	5
@RMMERGENOTPEN	equ	12
@RMMASKNOTPEN	equ	3
@RMMERGEPEN	equ	15
@RMNOTMERGEPEN	equ	2
@RMMASKPEN	equ	9
@RMNOTMASKPEN	equ	8
@RMXORPEN	equ	7
@RMNOTXORPEN	equ	10
@CTEDITAUTOH	equ	128
@CTEDITAUTOV	equ	64
@LSSOLID	equ	0
@LSDASH	equ	1
@LSDOT	equ	2
@LSDASHDOT	equ	3
@LSDASHDOTDOT	equ	4
@LSINSIDE	equ	6
@SNDASYNC	equ	1
@SNDSYNC	equ	0
@SNDLOOP	equ	8
@SNDNOSTOP	equ	16
@SCROLLUP	equ	0
@SCROLLDOWN	equ	1
@SCROLLLEFT	equ	2
@SCROLLRIGHT	equ	3
@CTLBTNBITMAP	equ	128
@CTLBTNMULTI	equ	8192
@CTLSTCBITMAP	equ	14
@CTLSTCMULTI	equ	1
@CTLSTCSIMPLE	equ	11
@IDCREATE	equ	1
@NAVIGATE	equ	0
@GOHOME	equ	1
@GOBACK	equ	2
@GOFORWARD	equ	3
@REFRESH	equ	4
@GETTITLE	equ	6
@CTLBTNDEFAULT	equ	1
@CTLBTNFLAT	equ	32768
@IDBEFORENAV	equ	32781
@BACKENABLED	equ	7
@FORWARDENABLED	equ	8
@CANCELNAV	equ	9
@GETPOSTDATA	equ	10
@GETHEADERS	equ	11
@GETNAVURL	equ	12
@IDNAVCOMPLETE	equ	32782
@IDSTATUSTEXTUPDATE	equ	32784
@SFSTRIKEOUT	equ	32
@CTEDITRETURN	equ	4096
@TYPESTRING	equ	0
@TYPECHAR	equ	1
@TYPEINT	equ	2
@TYPEFLOAT	equ	3
@TYPEMEMORY	equ	5
@TYPEFILE	equ	6
@TYPEWINDOW	equ	9
@TYPEDIALOG	equ	10
@TYPEBFILE	equ	11
@TYPEWORD	equ	13
@TYPEDOUBLE	equ	14
@TYPEUSER	equ	15
@TYPEPOINTER	equ	16
@TYPEINT64	equ	17
@TYPEUINT64	equ	18
@TYPEUINT	equ	19
@TYPESWORD	equ	30
@TYPESCHAR	equ	31
@TYPEWSTRING	equ	32
@BROWSESTOP	equ	5
@ENSETFOCUS	equ	256
@ENKILLFOCUS	equ	512
@ENCHANGE	equ	768
@ENUPDATE	equ	1024
@ENERRSPACE	equ	1280
@ENMAXTEXT	equ	1281
@ENHSCROLL	equ	1537
@ENVSCROLL	equ	1538
@ENTABKEY	equ	2561
@ENENTERKEY	equ	2560
@LBNDBLCLK	equ	2
@LBNERRSPACE	equ	-2
@LBNKILLFOCUS	equ	5
@LBNSETFOCUS	equ	4
@LBNSELCHANGE	equ	1
@LBNSELCANCEL	equ	3
@CBNDBLCLICK	equ	2
@CBNERRSPACE	equ	-1
@CBNKILLFOCUS	equ	4
@CBNSETFOCUS	equ	3
@CBNDROPDOWN	equ	7
@CBNCLOSEUP	equ	8
@CBNEDITCHANGE	equ	5
@CBNEDITUPATE	equ	6
@CBNSELCHANGE	equ	1
@CBNSELENDOK	equ	9
@CBNSELENDCANCEL	equ	10
@NMCLICK	equ	-2
@NMDBLCLK	equ	-3
@NMKILLFOCUS	equ	-8
@NMSETFOCUS	equ	-7
@NMRCLICK	equ	-5
@LVNCOLUMNCLICK	equ	-108
@LVNKEYDOWN	equ	-155
@LVNBEGINLABELEDIT	equ	-105
@LVNENDLABELEDIT	equ	-106
@LVNITEMCHANGED	equ	-101
@LVNITEMCHANGING	equ	-100
@LVNINSERTITEM	equ	-102
@LVNDELETEITEM	equ	-103
@ENSELCHANGE	equ	1794
@ENREQUESTRESIZE	equ	1793
@LVDELETEALL	equ	0
@LVDELETECOLUMN	equ	1
@LVDELETEITEM	equ	2
@LVINSERTITEM	equ	3
@LVINSERTCOLUMN	equ	4
@LVSETTEXT	equ	5
@LVGETTEXT	equ	6
@LVGETSELCOUNT	equ	7
@LVSETCOLUMNTEXT	equ	8
@LVGETCOLUMNTEXT	equ	9
@LVSETCOLWIDTH	equ	10
@LVGETCOLWIDTH	equ	11
@LVSETSELECTED	equ	12
@LVGETSELECTED	equ	13
@LVFINDITEM	equ	14
@LVGETTOPINDEX	equ	15
@LVGETCOUNT	equ	16
@RTCANUNDO	equ	0
@RTDELETESEL	equ	1
@RTCOPY	equ	2
@RTCUT	equ	3
@RTEMPTYUNDO	equ	4
@RTFINDTEXT	equ	5
@RTGETEVENTMASK	equ	6
@RTSETEVENTMASK	equ	7
@RTGETFIRSTLINE	equ	8
@RTSETLIMITTEXT	equ	9
@RTGETLIMITTEXT	equ	10
@RTGETLINE	equ	11
@RTGETLINECOUNT	equ	12
@RTGETMODIFIED	equ	13
@RTSETMODIFIED	equ	14
@RTSETSELECTION	equ	15
@RTGETSELECTION	equ	16
@RTGETSELTEXT	equ	17
@RTGETTEXTLENGTH	equ	18
@RTHIDESEL	equ	19
@RTLINEFROMCHAR	equ	20
@RTCHARFROMLINE	equ	187
@RTGETLINELENGTH	equ	21
@RTSCROLL	equ	22
@RTPASTE	equ	23
@RTREPLACESEL	equ	24
@RTSETDEFAULTFONT	equ	25
@RTSETDEFAULTCOLOR	equ	26
@RTSETSELFONT	equ	27
@RTSETSELCOLOR	equ	28
@RTSETMARGINS	equ	29
@RTSETLINEWIDTH	equ	31
@RTUNDO	equ	32
@RTSAVE	equ	33
@RTLOAD	equ	34
@RTPASTESPECIAL	equ	35
@RTSETALIGNMENT	equ	36
@RTSETCHAROFFSET	equ	37
@SWSETPANES	equ	0
@SWSETPANETEXT	equ	1
@SWRESIZE	equ	2
@ENMNONE	equ	0
@ENMCHANGE	equ	1
@ENMUPDATE	equ	2
@ENMSCROLL	equ	4
@ENMKEYEVENTS	equ	65536
@ENMMOUSEEVENTS	equ	131072
@ENMREQUESTRESIZE	equ	262144
@ENMSELCHANGE	equ	524288
@ENM_DROPFILES	equ	1048576
@ENM_PROTECTED	equ	2097152
@EDCANUNDO	equ	0
@EDDELETESEL	equ	1
@EDCOPY	equ	2
@EDCUT	equ	3
@EDEMPTYUNDO	equ	4
@EDGETFIRSTLINE	equ	8
@EDSETLIMITTEXT	equ	9
@EDGETLIMITTEXT	equ	10
@EDGETLINE	equ	11
@EDGETLINECOUNT	equ	12
@EDGETMODIFIED	equ	13
@EDSETMODIFIED	equ	14
@EDSETSELECTION	equ	15
@EDGETSELECTION	equ	16
@EDLINEFROMCHAR	equ	20
@EDCHARFROMLINE	equ	187
@EDGETLINELENGTH	equ	21
@EDPASTE	equ	23
@EDREPLACESEL	equ	24
@EDSETMARGINS	equ	29
@EDUNDO	equ	32
@LVSALIGNLEFT	equ	2048
@LVSALIGNTOP	equ	0
@LVSAUTOARRANGE	equ	256
@LVSEDITLABELS	equ	512
@LVSICON	equ	0
@LVSLIST	equ	3
@LVSNOCOLUMNHEADER	equ	16384
@LVSNOLABELWRAP	equ	128
@LVSNOSCROLL	equ	8192
@LVSNOSORTHEADER	equ	32768
@LVSREPORT	equ	1
@LVSSHOWSELALWAYS	equ	8
@LVSSINGLESEL	equ	4
@LVSSMALLICON	equ	2
@LVSSORTASCENDING	equ	16
@LVSSORTDESCENDING	equ	32
@CTCOMBOSIMPLE	equ	1
@CTCOMBOSORT	equ	256
@CTCOMBOAUTOHSCROLL	equ	64
@RTALIGNLEFT	equ	1
@RTALIGNCENTER	equ	3
@RTALIGNRIGHT	equ	2
@CTEDITNUMBER	equ	8192
@BROWSEPRINT	equ	13
@RTPRINT	equ	38
@IMGBITMAP	equ	0
@IMGICON	equ	1
@IMGCURSOR	equ	2
@IMGEMF	equ	3
@IMGSCALABLE	equ	4
@IMGOEM	equ	256
@BROWSELOAD	equ	14
@GETSTATUSTEXT	equ	15
@BROWSESEARCH	equ	16
@IMGMAPCOLORS	equ	4096
@TBTOP	equ	1
@TBBOTTOM	equ	3
@TBRIGHT	equ	131
@TBLEFT	equ	129
@TBNOALIGN	equ	8
@TBTOOLTIPS	equ	256
@TBWRAPABLE	equ	512
@TBFLAT	equ	2048
@TBLIST	equ	4096
@TBNORESIZE	equ	4
@TBFROMHANDLE	equ	65536
@TBRESIZE	equ	0
@TBSETBITMAPSIZE	equ	1
@TBSETBUTTONSIZE	equ	2
@TBENABLEBUTTON	equ	3
@TVSDISABLEDRAGDROP	equ	16
@TVSEDITLABELS	equ	8
@TVSFULLROWSELECT	equ	4096
@TVSHASBUTTONS	equ	1
@TVSHASLINES	equ	2
@TVSINFOTIP	equ	2048
@TVSLINESATROOT	equ	4
@TVSNOHSCROLL	equ	32768
@TVSNONEVENHEIGHT	equ	16384
@TVSNOSCROLL	equ	8192
@TVSNOTOOLTIPS	equ	128
@TVSRTLREADING	equ	64
@TVSSHOWSELALWAYS	equ	32
@TVSSINGLEEXPAND	equ	1024
@TVSTRACKSELECT	equ	512
@TVSCHECKBOXES	equ	256
@TVNBEGINDRAG	equ	-407
@TVNBEGINLABELEDIT	equ	-410
@TVNBEGINRDRAG	equ	-408
@TVNDELETEITEM	equ	-409
@TVNENDLABELEDIT	equ	-411
@TVNGETDISPINFO	equ	-403
@TVNGETINFOTIP	equ	-413
@TVNITEMEXPANDED	equ	-406
@TVNITEMEXPANDING	equ	-405
@TVNKEYDOWN	equ	-412
@TVNSELCHANGED	equ	-402
@TVNSELCHANGING	equ	-401
@TVNSETDISPINFO	equ	-404
@TVNSINGLEEXPAND	equ	-415
@RESCURSOR	equ	1
@RESBITMAP	equ	2
@RESICON	equ	3
@RESMENU	equ	4
@RESDIALOG	equ	5
@RESSTRING	equ	6
@RESACCEL	equ	9
@RESDATA	equ	10
@RESMESSAGETABLE	equ	11
@RESGROUPCURSOR	equ	12
@RESGROUPICON	equ	14
@RESVERSION	equ	16
@TBSETLABELS	equ	4
@TBSETBUTTONSTYLE	equ	5
@TBBUTTONCHECK	equ	2
@TBBUTTONGROUP	equ	4
@TBGETBUTTONSTATE	equ	6
@IDERASEBACKGROUND	equ	32783
@TBGETBUTTONWIDTH	equ	7
@TBGETBUTTONHEIGHT	equ	8
@TBTRANSPARENT	equ	32768
@TBSETTIP	equ	9
@IDDESTROY	equ	2
@IDSETCURSOR	equ	32
@EXCLIENTEDGE	equ	512
@EXLEFT	equ	0
@EXRIGHT	equ	4096
@EXSTATICEDGE	equ	131072
@EXWINDOWEDGE	equ	256
@BUTTON	equ	1
@CHECKBOX	equ	2
@RADIOBUTTON	equ	3
@EDIT	equ	4
@LISTBOX	equ	5
@COMBOBOX	equ	6
@STATIC	equ	7
@SCROLLBAR	equ	8
@GROUPBOX	equ	9
@RICHEDIT	equ	10
@LISTVIEW	equ	11
@STATUS	equ	12
@SYSBUTTON	equ	13
@TREEVIEW	equ	14
@RGNBUTTON	equ	20
@EXCONTROL	equ	99
@MB_ICONEXCLAMATION	equ	48
@MB_ICONINFORMATION	equ	64
@MB_ICONQUESTION	equ	32
@MB_ICONSTOP	equ	16
@MB_OK	equ	0
@MB_OKCANCEL	equ	1
@MB_ABORTRETRYIGNORE	equ	2
@MB_YESNOCANCEL	equ	3
@MB_YESNO	equ	4
@MB_RETRYCANCEL	equ	5
@MB_CANCELTRYCONTINUE	equ	6
@IDABORT	equ	3
@IDRETRY	equ	4
@IDIGNORE	equ	5
@IDYES	equ	6
@IDNO	equ	7
@IDTRYAGAIN	equ	10
@IDCONTINUE	equ	11
@FILE_ARCHIVE	equ	32
@FILE_COMPRESSED	equ	2048
@FILE_DEVICE	equ	64
@FILE_DIRECTORY	equ	16
@FILE_ENCRYPTED	equ	16384
@FILE_HIDDEN	equ	2
@FILE_NORMAL	equ	128
@FILE_READONLY	equ	1
@FILE_SYSTEM	equ	4
@FALT	equ	16
@FCONTROL	equ	8
@FNOINVERT	equ	2
@FSHIFT	equ	4
@FVIRTKEY	equ	1
; ---------------------- DX2D ----------------------------------------
@SDXPOS	equ	0
@SDYPOS	equ	1
@SDFRAME	equ	2
@SDXVEL	equ	3
@SDYVEL	equ	4
@SDWIDTH	equ	6
@SDHEIGHT	equ	5
@SDTRANSKEY	equ	7
@SDBLTTYPE	equ	8
@SDSCALE	equ	9
@SDSHADOW	equ	10
@SDANGLE	equ	11
@SDALPHA	equ	12
@SDSHADOWX	equ	13
@SDSHADOWY	equ	14
@BLTCOPY	equ	0
@BLTALPHA	equ	1
@BLTSCALED	equ	3
@BLTSHADOW	equ	4
@BLTROTOZOOM	equ	7
@BLTHFLIP	equ	8
@BLTVFLIP	equ	9
@BLTTRANS	equ	100
@BLTTRANSALPHA	equ	101
@BLTTRANSSCALED	equ	103
@BLTTRANSSHADOW	equ	104
@BLTTRANSROTOZOOM	equ	107
@BLTTRANSHFLIP	equ	108
@BLTTRANSVFLIP	equ	109
@BLOCKCOPY	equ	0
@ALPHA	equ	1
@SCALED	equ	3
@SHADOW	equ	4
@ROTOZOOM	equ	7
@HFLIP	equ	8
@VFLIP	equ	9
@TRANS	equ	100
@TRANSALPHA	equ	101
@TRANSSCALED	equ	103
@TRANSSHADOW	equ	104
@TRANSROTOZOOM	equ	107
@TRANSHFLIP	equ	108
@TRANSVFLIP	equ	109
@JOYTYPE_UNKNOWN	equ	1
@JOYTYPE_TRADITIONAL	equ	 2
@JOYTYPE_FLIGHTSTICK	equ	 3
@JOYTYPE_GAMEPAD	equ	4
@JOYTYPE_RUDDER	equ	 5
@JOYTYPE_WHEEL	equ	6
@JOYTYPE_HEADTRACKER	equ	7
@XAXIS	equ	0
@YAXIS	equ	1
