.686p
.model flat
include ..\Macros.inc
include ..\EBasic.inc
; ===========================================================================
extern ebvarstable:near
; ===========================================================================
.code
;$command ArraySearchRow(Array:POINTER,Typ:UINT,UboundRow:UINT,Find:POINTER,OPT Column=0:UINT,OPT Start=0:UINT,OPT SizeOfElement=0:UINT),INT
;Sequential search
; =============== S U B	R O U T	I N E =======================================
ArraySearchRow proc near syscall public uses esi edi ebx Array:POINTER,Typ:UINT,UboundRow:UINT,Find:POINTER,Column:UINT,Start:UINT,SizeOfElement:UINT
		mov esi, Array
		inc UboundRow
		mov ebx, UboundRow
		movzx eax, byte ptr Typ
		mov	edi, SizeOfElement
		.if (edi == 0)
			lea	edx, ebvarstable
			movzx edi, word ptr [edx+eax*2]
			.if (al == @TYPESTRING)
Lstr:			call Index
				.if (ebx != 0)
				@@:	invokeE STRCMP$, esi,Find
					jz Found
					add esi, edi
					dec ebx
					jnz @B
				.endif
			.elseif (al == @TYPEWSTRING)
Lwstr:			call Index
				.if (ebx != 0)
				@@:	invokeA lstrcmpW, esi,Find
					test eax, eax
					jz Found
					add esi, edi
					dec ebx
					jnz @B
				.endif
			.else
Luser:			call Index
				.if (ebx != 0)
				@@:	invokeE MEMCMP, esi,Find,edi
					jz Found
					add esi, edi
					dec ebx
					jnz @B
				.endif
			.endif
		.else 
			.if (al == @TYPESTRING)
				jmp Lstr
			.elseif (al ==  @TYPEWSTRING)
				jmp Lwstr
			.endif
			jmp Luser
		.endif
		xor eax, eax
		dec eax
Exit:	ret 28
Found:	mov eax, UboundRow
		sub	eax, ebx
		jmp Exit
; =============== S U B	R O U T	I N E =======================================
Index:  mov eax, Column
		mul ebx
		mul	edi
		add esi, eax
		mov eax, Start
		sub ebx, eax
		mul	edi
		add	esi, eax
		retn
ArraySearchRow endp
end 