.686p
.model flat
include ..\Macros.inc
include ..\EBasic.inc
; ===========================================================================
extrn ebvarstable	:near
extrn sorttable		:near
extrn AscCmp		:byte
extrn SortSTRING	:near
extrn Direction		:dword
; ===========================================================================
.code
;$command ArraySearchRowS(Array:POINTER,Typ:UINT,UboundRow:UINT,Find:POINTER,OPT Column=0:UINT,OPT Up=1:UINT,OPT SizeOfElement=0:UINT),INT
;Search in sorted array (bubble search)
; =============== S U B	R O U T	I N E =======================================
ArraySearchRowS proc near syscall public uses esi edi ebx Array:POINTER,Typ:UINT,UboundRow:UINT,Find:POINTER,Column:UINT,Up:UINT,SizeOfElement:UINT
		LOCAL Base	:DWORD
		LOCAL Jump	:DWORD
		mov	eax, UboundRow
		inc eax
		push eax
		mov esi, Array									;ESI = Array
		movzx eax, byte ptr Typ
		mov edi, SizeOfElement							;EDI = SizeOfElement
		.if (edi == 0)
			lea edi,  ebvarstable
			movzx edi, word ptr [edi+eax*2]
		.endif
		.if (al == @TYPESTRING) && (AscCmp == FALSE) 	;EBX = &cmpfunc
			lea ebx, SortSTRING
		.else
			lea ebx, sorttable
			mov ebx, [ebx+eax*4]
		.endif
		mov Jump, ebx
		m2m Direction, Up
		mov eax, Column
		mul dword ptr [esp]
		mul edi
		add esi, eax
		mov Base, esi
		xor ebx, ebx
@@:		pop	ecx
		jecxz NotFound		
		shr ecx, 1
		setnc bl
		push ecx
		mov eax, edi
		mul ecx
		add eax, esi
		mov ecx, Find
		xchg eax, ecx
		invokeE [Jump]
		jb  @B
		je  @F
		mov esi, ecx
		add esi, edi
		sub [esp], ebx
		jmp	@B	
@@:		sub ecx, Base
		xchg eax, ecx
		xor edx, edx
		div edi
		pop ecx	
@@:		ret 28
NotFound:xchg eax, ecx
		dec eax
		jmp @B		
ArraySearchRowS endp
end