.686p
.model flat
include ..\Macros.inc
include ..\EBasic.inc
; ------------------------------------------------------------------
extrn Direction		:byte
extrn sorttable		:byte
; ------------------------------------------------------------------
LVM_GETITEM 	equ	1005h
LVM_INSERTITEM 	equ	1007h
; ------------------------------------------------------------------
_LVSORT STRUCT					;_LVITEM 
	nmask			DWORD	?;+000	
	iItem			DWORD	?;+004
	iSubItem		DWORD	?;+008
	state			DWORD	?;+012
	stateMask		DWORD	?;+016
	pszText			DWORD	?;+020
	cchTextMax		DWORD	?;+024
	iImage			DWORD	?;+028
	lParam			DWORD	?;+032	
	iGroupId		DWORD	?;+036
	cColumns		DWORD	?;+040
	puColumns		DWORD	?;+044
	;---------------------------_LVITEM ENDS
	WinHwnd			DWORD	?;+048
	LV				DWORD	?;+052
	HWND_LV			DWORD	?;+056
	SortingOrder 	DWORD	?;+060
	SortType		DWORD	?;+064
	SortParam 		DWORD	?;+068
_LVSORT ENDS						
; ===========================================================================
.const
$DDMMYYYY	db "DD.MM.YYYY",0
$MMDDYYYY	db "MM.DD.YYYY",0
$DDYYYYMM	db "DD.YYYY.MM",0
$MMYYYYDD	db "MM.YYYY.DD",0
$YYYYDDMM	db "YYYY.DD.MM",0
.code
;$command INSERTITEM(LVSORT:_LVSORT),INT
; =============== S U B R O U T I N E =======================================
align 4
INSERTITEM proc near syscall public USES esi LVSORT:POINTER
					mov esi, LVSORT
					mov eax, [esi._LVSORT.HWND_LV]
					.if (eax == 0)
						invokeA GetDlgItem, [esi._LVSORT.WinHwnd],[esi._LVSORT.LV]
						mov [esi._LVSORT.HWND_LV], eax
					.endif
					invokeA SendMessageA,eax,LVM_INSERTITEM,0,esi
					ret 4
INSERTITEM endp
;$command GETLVSORTCALLBACK(),POINTER
; =============== S U B R O U T I N E =======================================
GETLVSORTCALLBACK proc near public	
					mov eax, offset LVSort
					retn
GETLVSORTCALLBACK endp
; =============== CALLBACK FUNCTION =========================================
align 16
LVSort proc near syscall public USES ebx edi esi lParam1:DWORD,lParam2:DWORD,LVSORT:POINTER
LOCAL	STR01[256]:BYTE
LOCAL	STR02[256]:BYTE
					mov esi, LVSORT
					mov [esi._LVSORT.cchTextMax], 0FFh
					a2m [esi._LVSORT.pszText], STR02
					m2m [esi._LVSORT.iItem], lParam1
					mov eax, [esi._LVSORT.HWND_LV]
					.if (eax == 0)
						invokeA GetDlgItem,dword ptr [esi._LVSORT.WinHwnd],dword ptr [esi._LVSORT.LV]
						mov [esi._LVSORT.HWND_LV], eax
					.endif
					mov edi, eax
					invokeA SendMessageA,edi,LVM_GETITEM,0,esi
					m2m [esi._LVSORT.iItem], lParam2 
					a2m [esi._LVSORT.pszText], STR01
					invokeA SendMessageA,edi,LVM_GETITEM,0,esi
					lea ebx, STR02
					lea edi, STR01
					xor	ecx, ecx
					mov cl, byte ptr [esi._LVSORT.SortType]
					push offset Exit
					jecxz ItsASCString			; 00 - ASCII (Sort)
					dec	ecx
					jz ItsDatum					; 01 - Datum
					dec	ecx
					jz ItsNumber				; 02 - Byte,Sbyte,Word,Sword,Uint32,Int32,Int64,Uint64,Float,Double
					dec	ecx					
					jz ItsBinary				; 03 - Binary
					dec ecx
					jz ItsHex					; 04 - Hex
					dec	ecx
					jz	StringSort				; 05 - StringSort
					xor eax, eax
					retn
;------------------------------------- STRING ----------------------------------------
StringSort:			.if (byte ptr [esi._LVSORT.SortingOrder] == 0)
						xchg edi, ebx
					.endif
 					invokeA lstrcmpA, ebx, edi
					retn
;------------------------------------- ASCII -----------------------------------------
ItsASCString:		.if (byte ptr [esi._LVSORT.SortingOrder] == 0)
						xchg edi, ebx
					.endif
 					invokeE STRCMP$, ebx, edi
					retn
;-------------------------------------   HEX   -----------------------------------------
ItsHex:				invokeE VALHEX,ebx
					push edx
					push eax
					invokeE VALHEX,edi
@@:					pop ebx
					pop edi
					xor ecx, ecx
					xchg ecx, eax
					.if (byte ptr [esi._LVSORT.SortingOrder] != al)
						xchg ecx, ebx
						xchg edx, edi
					.endif 
					cmp edx, edi
					jnz 	Beu2
					cmp ecx, ebx
					jmp 	Beu1
;----------- Byte,Sbyte,Word,Sword,Uint32,Int32,Float,Double,Int64,Uint64---------------
ItsNumber:			.if (byte ptr [esi._LVSORT.SortParam] == @TYPEUINT64)
						invokeE VAL64,ebx					
						push edx
						push eax
						invokeE VAL64,edi
						jmp 	@B
					.endif
					invokeE VAL_,ebx
					push edx
					push eax
					invokeE VAL_,edi
					push edx
					push eax
					fld qword ptr [esp]
					pop eax
					pop eax
					fld qword ptr [esp]
					pop eax
					pop eax
					.if (byte ptr [esi._LVSORT.SortingOrder] == 0)
						fxch st(1)
					.endif
					xor	eax, eax
					fcomip st(0), st(1)
					ffree st(0)
Beu1:				jz T01
Beu2:				ja T02
					dec eax
					dec eax
T02:				inc eax
T01:				retn
;------------------------------------- BINARY -----------------------------------------
ItsBinary:			mov al, byte ptr [esi._LVSORT.SortingOrder]
					mov Direction, al
					invokeE VALBIN,ebx
					push edx
					push eax
					invokeE VALBIN,edi
					push edx
					push eax
					movzx eax, byte ptr [esi._LVSORT.SortParam]
					lea edx, sorttable
					mov edx, [edx+eax*4]
					lea eax, [esp+8]
					lea ecx, [esp]
					invokeE edx
					pushfd
					xor eax, eax
					popfd
					call Beu1
					add esp, 16
					retn
;------------------------------------- DATUM -----------------------------------------
MMYYYYDD:			mov eax, [ebx+3]
					mov cx, [ebx]				; "MM"
					mov dx, [ebx+8]				; "DD"
					mov [ebx], eax
					mov [ebx+4], byte ptr "."
					mov [ebx+5], cx
					mov [ebx+8], dx
					pop edi
					mov eax, [edi+3]
					mov cx, [edi]				; "MM"
					mov dx, [edi+8]				; "DD"
					mov [edi], eax
					mov [edi+4], byte ptr "."
					mov [edi+5], cx
					mov [edi+8], dx
					retn
;-------------------------------------------------------------------------------------
DDYYYYMM:			mov eax, [ebx+3]
					mov cx, [ebx]				; "DD"
					mov dx, [ebx+8]				; "MM"
					mov [ebx], eax
					mov [ebx+4], byte ptr "."
					mov [ebx+5], dx
					mov [ebx+8], cx
					pop edi
					mov eax, [edi+3]
					mov cx, [edi]				; "DD"
					mov dx, [edi+8]				; "MM"
					mov [edi], eax
					mov [edi+4], byte ptr "."
					mov [edi+5], dx
					mov [edi+8], cx
					retn
;------------------------------------------------------------------------------------- 
ItsDatum:			push ItsASCString
					push edi
					mov edi, [esi._LVSORT.SortParam]	;DateFormat
					invokeE UCASESTR,edi
					invokeE STRCMP$,offset $DDMMYYYY,edi 
					jz 		DDMMYYYY
					invokeE STRCMP$,offset $MMDDYYYY,edi
					jz 		MMDDYYYY
					invokeE STRCMP$,offset $DDYYYYMM,edi
					jz 		DDYYYYMM
					invokeE STRCMP$,offset $MMYYYYDD,edi
					jz 		MMYYYYDD
					invokeE STRCMP$,offset $YYYYDDMM,edi
					jz 		YYYYDDMM
					pop edi
					retn
;-------------------------------------------------------------------------------------
DDMMYYYY:			mov eax, [ebx+6]
					mov cx, [ebx]				; "DD"
					mov dx, [ebx+3]				; "MM"
					mov [ebx], eax
					mov [ebx+4], byte ptr "."
					mov [ebx+5], dx
					mov [ebx+7], byte ptr "."
					mov [ebx+8], cx
					pop edi
					mov eax, [edi+6]
					mov cx, [edi]				; "DD"
					mov dx, [edi+3]				; "MM"
					mov [edi], eax
					mov [edi+4], byte ptr "."
					mov [edi+5], dx
					mov [edi+7], byte ptr "."
					mov [edi+8], cx
					retn
MMDDYYYY:			mov eax, [ebx+6]
					mov cx, [ebx]				; "MM"
					mov dx, [ebx+3]				; "DD"
					mov [ebx], eax
					mov [ebx+4], byte ptr "."
					mov [ebx+5], cx
					mov [ebx+7], byte ptr "."
					mov [ebx+8], dx
					pop edi
					mov eax, [edi+6]
					mov cx, [edi]				; "MM"
					mov dx, [edi+3]				; "DD"
					mov [edi], eax
					mov [edi+4], byte ptr "."
					mov [edi+5], cx
					mov [edi+7], byte ptr "."
					mov [edi+8], dx
					retn
;-------------------------------------------------------------------------------------
YYYYDDMM:			mov cx, [ebx+5]				; "DD"
					mov dx, [ebx+8]				; "MM"
					mov [ebx+5], dx
					mov [ebx+8], cx
					pop edi
					mov cx, [edi+5]				; "DD"
					mov dx, [edi+8]				; "MM"
					mov [edi+5], dx
					mov [edi+8], cx
					retn
;---------------------------------- EXIT ---------------------------------------------
Exit:				ret 12
LVSort endp
end
